#include <bits/stdc++.h>

using namespace std;

int b[100010];

long long cna(long long a, long long b)
{
    long long c=1;
    
    for(int i=1; i<=b; i++)
    {
        c*=a;
    }
    
    return c;
}

int main() 
{
    long long n,m,sum=0,c,m1;
    
    cin >> n;
    cin >> m;
    
    int a[n];
    
    for(int i=1; i<=m1; i++)
    {
        if(m1==m)
        {
            cin >> b[i];
        }
        if(i==m1)
        {
            m1=n;
        }
        
        a[i]=i;
    }
    
    cin >> c;
    
    for(int i=0; i<=n-m; i++)
    {
        for(int j=1; j<=m; j++)
        {
            a[i+b[j]]=a[i+j];
        }
    }
    
    for(int i=1; i<=n; i++)
    {
        sum+=(cna(c, i)*a[i]);
    }

    cout << sum%998244353 << endl;
    
    return 0;
}